VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsShellNotify"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event ShellNotifyEvent(dwItem1 As Long, dwItem2 As Long, idEvent As Long)

Private m_ClassKey As String

Public Function StartShellNotify(ByVal lHwnd As Long, Optional ByVal _
    lSHSpecialFolder As SHSpecialFolderIDs = CSIDL_DESKTOP, Optional ByRef sPaths _
    As Variant, Optional ByVal lEvents As SHCN_EventIDs = SHCNE_ALLEVENTS Or _
    SHCNE_INTERRUPT, Optional ByVal bRecursive As Boolean = True) As Boolean

    Dim bRet As Boolean

    bRet = False

    If lHwnd <> 0 Then

        If modShellNotify.Subclass(lHwnd, AddressOf WndProc) = True Then

            If modShellNotify.StartNotify(lHwnd, lSHSpecialFolder, sPaths, _
                lEvents, bRecursive) = True Then

                bRet = True

            End If
        End If

    End If

    StartShellNotify = bRet

End Function

Friend Sub RaiseShellEvent(dwItem1 As Long, dwItem2 As Long, idEvent As Long)

    RaiseEvent ShellNotifyEvent(dwItem1, dwItem2, idEvent)

End Sub

Public Sub StopShellNotify()

    Call modShellNotify.StopNotify

End Sub

Private Sub Class_Initialize()

    m_ClassKey = CStr(ObjPtr(Me))

    Call m_ShellNotifyClass.Add(Me, m_ClassKey)

End Sub

Private Sub Class_Terminate()

    Call StopNotify

    Call m_ShellNotifyClass.Remove(m_ClassKey)

End Sub


